/*
 * HARK/hark-base
 *
 * Copyright (C) 2008-2018
 *
 */

#if !defined(HARK_BASE_SOURCE_H_INCLUDED)
#define HARK_BASE_SOURCE_H_INCLUDED 1

#include "Object.h"

namespace HARK
{
    class Source : public Object {
    public:
	enum TFDim {
	    TFHeight,
	    TFDirection,
	    TFRange
	};
	enum CompareMode {
	    DEG,
	    TFINDEX
	};

    public:
	Source();
	Source(const Source &src);

    public:
	int tfindexDistance(const int *y) const;
	int tfindexDistance(const Source &src) const;

	float angle(const float *y) const;
	float angle(const Source &src) const;

	virtual ObjectRef clone();
	virtual void printOn(std::ostream &out) const;
	void readFrom(std::istream &in);

    public:
	float x[3];
	float power;
	int id;
	float remaining;
	int count;
	int last_found_count;

	int tfindex[3];
	int tfindex_max[3];
	int tfindex_min[3];
	CompareMode compare_mode;
    };

    std::istream &operator >> (std::istream &in, Source &src);
}

#endif

/* end of file */
