/*
 * HARK/hark-base
 *
 * Copyright (C) 2008-2018
 *
 */

#if !defined(HARK_BASE_MULTITHREAD_H_INCLUDED)
#define HARK_BASE_MULTITHREAD_H_INCLUDED 1

#include "common.h"

#include <pthread.h>

namespace HARK
{
    class AtomicCounter
    {
    private:
	int count;
	pthread_mutex_t mutex;
    
    public:
	AtomicCounter(int c = 0);
	~AtomicCounter();

	void inc();
	bool dec();
	bool unique() const;
    };

    //class FastMutex
    //{
    //private:
    //    pthread_mutex_t mutex;
    //
    //public:
    //    FastMutex()
    //    {
    //        pthread_mutex_init(&mutex, NULL);
    //    }
    //
    //    ~FastMutex()
    //    {
    //        pthread_mutex_destroy(&mutex);
    //    }
    //
    //    void lock()
    //    {
    //        pthread_mutex_lock(&mutex);
    //    }
    //
    //    void unlock()
    //    {
    //        pthread_mutex_unlock(&mutex);
    //    }
    //};
}

#endif

/* end of file */
