/*
 * HARK/hark-base
 *
 * Copyright (C) 2008-2018
 *
 */

#include "Vector.h"

#include "Object.h"
#include "ObjectParser.h"
#include "ObjectRef.h"
#include "operators.h"
#include <complex>

namespace HARK
{
    DECLARE_TYPE(Vector<float>);
    DECLARE_TYPE(Vector<double>);
    DECLARE_TYPE(Vector<int>);
    DECLARE_TYPE(Vector<ObjectRef>);
    DECLARE_TYPE(Vector<std::string>);
    DECLARE_TYPE(Vector<String>);
    DECLARE_TYPE2("Vector", Vector<float>);
    DECLARE_TYPE2("Vector<complex<float>>", Vector<std::complex<float> >);
    DECLARE_TYPE2("Vector<complex<double>>", Vector<std::complex<double> >);
}

/* end of file */
