/*
 * HARK/hark-base
 *
 * Copyright (C) 2008-2018
 *
 */

#include "multithread.h"

namespace HARK
{
    AtomicCounter::AtomicCounter(int c) :
	count(c)
    {
	pthread_mutex_init(&this->mutex, NULL);
    }

    AtomicCounter::~AtomicCounter()
    {
	pthread_mutex_destroy(&this->mutex);
    }

    void
    AtomicCounter::inc()
    {
	pthread_mutex_lock(&this->mutex);
	++this->count;
	pthread_mutex_unlock(&this->mutex);
    }

    bool
    AtomicCounter::dec()
    {
	int tmp;
	pthread_mutex_lock(&this->mutex);
	--this->count;
	tmp = this->count;
	pthread_mutex_unlock(&this->mutex);
	return (tmp > 0);
    }

    bool
    AtomicCounter::unique() const
    {
	return this->count == 1;
    }

}

/* end of file */
